<?php
// echo "test";
// die();
$memberSubscriptionObj = new memberSubscription();

class memberSubscription {

    var $mDb; 
    var $mConfig; 
    var $mMailer;
    var $dateTime;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();
        $this->dateTime = date('Y-m-d H:i:s');

    }
function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            // echo "test"; die();
            return $data;
        }
    }

    
    
function getAllMemberSubscription($start, $perpage, $lang_code, $type, $sort)
{
    $result = array();
    
    $sql = "SELECT m.*, u.full_name as added_by FROM member_subscription m ";
    $sql .= "LEFT JOIN trail_duration td ON m.id = td.id ";
    $sql .= "LEFT JOIN users u ON m.user_id = u.id ";
    $sql .= "WHERE m.id > 0 ";
    
    $sql .= $sort === 'sort' ? "ORDER BY m.`sort` {$type}" : "ORDER BY m.{$sort} {$type}";
    $sql .= " LIMIT " . (int)$start . ", " . (int)$perpage;
    
    $stmt = $this->mDb->connect()->prepare($sql);
   
    $stmt->execute();
    
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
    
    // Update start_date if plan_type is 'trail'
    
    return $result;
}

   
function getMemberSubscriptionCount($searchName,$lang_code) {
	$sql = "SELECT COUNT(m.`id`) as 'count' FROM `member_subscription` m ";
    
	return $this -> mDb -> getOne($sql); 
}
function getTrialDuration($trialDurationType)
{
    $sql = "SELECT duration FROM trail_duration WHERE member_type = :trialDurationType";
    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->bindParam(':trialDurationType', $trialDurationType, PDO::PARAM_STR);
    $stmt->execute();
    $result = $stmt->fetchColumn();
    return $result;
}

function getPlanDuration($planDuration_id)
{
    $sql = "SELECT duration FROM subscription_plan WHERE id = :planDuration_id";
    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->bindParam(':planDuration_id', $planDuration_id, PDO::PARAM_INT);
    $stmt->execute();
    $result = $stmt->fetchColumn();
    return $result;
}
    
function addEditMemberSubscription($request, $member_subscription_id)
{
    $res = false;

    if (!$member_subscription_id || $member_subscription_id == "null" || $member_subscription_id == null) {
        // Add
        unset($request['operation']);

        $sql = "INSERT INTO `member_subscription` SET ";
        $sql .= " `added_by` = :added_by,";
        $sql .= " `user_id` = :user_id,";
        $sql .= " `entity_id` = :entity_id,";
        $sql .= " `date_added` = :date_added,";
        $sql .= " `sort` = :sort,";
        $sql .= " `plan_type` = :plan_type,";
        $sql .= " `start_date` = :start_date";
        if ($request['plan_type'] == 'plan') {
            $planDuration = $this->getPlanDuration($request['planDuration_id']);
            $planEndDate = date('Y-m-d', strtotime("+{$planDuration} days"));
            $sql .= ", `end_date` = :end_date";
        }
        if ($request['plan_type'] == 'trail') {
            $duration = $this->getTrialDuration($request['member_type']);
            $endDate = date('Y-m-d', strtotime("+{$duration} days"));
            $sql .= ", `end_date` = :end_date";
        }

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':added_by', $request['added_by'], PDO::PARAM_STR);
        $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
        $stmt->bindParam(':entity_id', $request['entity_id'], PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $this->dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_STR);
        $stmt->bindParam(':plan_type', $request['plan_type'], PDO::PARAM_STR);
        $stmt->bindParam(':start_date', $this->dateTime, PDO::PARAM_STR);
        if ($request['plan_type'] == 'plan') {
            $stmt->bindParam(':end_date', $planEndDate, PDO::PARAM_STR);
        }
        if ($request['plan_type'] == 'trail') {
            $stmt->bindParam(':end_date', $endDate, PDO::PARAM_STR);
        }

        if ($stmt->execute()) {
            return true;
        } else {
            return false;
        }
    } else {
        // Edit
        $check_query = "SELECT `id` FROM `member_subscription` WHERE `id` = :member_subscription_id";
        $stmt = $this->mDb->connect()->prepare($check_query);
        $stmt->bindParam(':member_subscription_id', $member_subscription_id, PDO::PARAM_INT);
        $stmt->execute();
        $check_result = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($check_result === false) {
            return "edit";
        } else {
            $sql = "UPDATE `member_subscription` SET ";
            $sql .= " `added_by` = :added_by, ";
            $sql .= " `user_id` = :user_id,";
            $sql .= " `entity_id` = :entity_id,";
            $sql .= " `sort` = :sort,";
            $sql .= " `price` = :price,";
            $sql .= " `plan_subscription_id` = :plan_subscription_id,";
            $sql .= " `end_date` = :end_date,";
            $sql .= " `start_date` = :start_date";
            $sql .= " WHERE `id` = :member_subscription_id";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':added_by', $request['added_by'], PDO::PARAM_STR);
            $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
            $stmt->bindParam(':entity_id', $request['entity_id'], PDO::PARAM_INT);
            $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_STR);
            $stmt->bindParam(':price', $request['price'], PDO::PARAM_STR);
            $stmt->bindParam(':plan_subscription_id', $request['plan_subscription_id'], PDO::PARAM_INT);
            $stmt->bindParam(':end_date', $request['end_date'], PDO::PARAM_STR);
            $stmt->bindParam(':start_date', $this->dateTime, PDO::PARAM_STR);
            $stmt->bindParam(':member_subscription_id', $member_subscription_id, PDO::PARAM_INT);

            if ($stmt->execute()) {
                return true;
            } else {
                return false;
            }
        }
    }
}
    
function deleteMemberSubscription($id)
{
    $MemberSubscription_id = '(' . implode(',', $id) . ')';

    $MemberSubscriptionsql = "DELETE FROM `member_subscription` ";
    $MemberSubscriptionsql .= "WHERE `id` IN  $MemberSubscription_id";
    $stmt = $this->mDb->connect()->prepare($MemberSubscriptionsql);
    
 
        if ($stmt->execute()) {
    return true;
} else {
    return false;
}
}

}
