<?php
// echo "test";
// die();
$planSubscriptionObj = new planSubscription();

class planSubscription {

    var $mDb; 
    var $mConfig; 
    var $mMailer;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();

    }
function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            // echo "test"; die();
            return $data;
        }
    }
    
    
function getAllplanSubscription($start,$perpage,$lang_code, $searchName, $type, $sort) {
        
         $result=array();
        
        $sql = "SELECT p.*, pl.name, pl.description ,pl.lang_code, u.full_name as added_by FROM subscription_plan p LEFT JOIN subscription_plan_langs pl ON pl.subscription_plan_id = p.id and pl.`lang_code`=:lang_code LEFT JOIN users u ON p.added_by = u.id WHERE p.id > 0 ";

        
        if ($searchName) {
        $sql .= " AND el.name LIKE :searchName"; 
    }
    
        // if ($type) {
        //     $sql .= " AND e.type LIKE :type"; 
        // }
    
        // Remove single quotes around limit placeholders
            $sql .= " LIMIT " . (int)$start . ", " . (int)$perpage;
    // echo $sql; die();
        
            $stmt = $this->mDb->connect()->prepare($sql);

     if (!$stmt) {
            
            throw new Exception("Error preparing the SQL statement."); 
        }

        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        if ($searchName) {
            $searchName = '%' . $searchName . '%';
            $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
        }
        // if ($type) {
        //     $type = '%' . $type . '%';
        //     $stmt->bindParam(':type', $type, PDO::PARAM_STR); 
        // }

        // Make sure the limit parameters are bound as integers

        // $stmt->bindParam(':start', $start, PDO::PARAM_STR); 
        // $stmt->bindParam(':perpage', $perpage, PDO::PARAM_STR);
        
        if (!$stmt->execute()) { 
             
            throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
        }
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC); // Fetch all results
   

    return $result;
}
 function getplanSubscriptionCount($searchName,$lang_code) {
	$sql = "SELECT COUNT(p.`id`) as 'count' FROM `subscription_plan` p ";
    $sql .= " LEFT JOIN `subscription_plan_langs` pl ON p.`id` = pl.`subscription_plan_id` ";
    $sql .= " WHERE p.`id` > 0 AND pl.`lang_code`  ='{$lang_code}' ";
    $sql .= $searchName ? ' AND pl.`name` like "%' . $searchName . '%"' : '';
    // $sql .= $partnerType ? ' AND a.`type` like "%' . $partnerType . '%"' : '';
    // $sql .= " AND c.`type` = '" . $partnerType . "'";
	return $this -> mDb -> getOne($sql); 
}
    
    
    
function addEditplanSubscription($request, $subscription_plan_id)
{
    $categoryLangObj = json_decode($request['langs']);
    $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);
    $res = false;

    if (!$subscription_plan_id || $subscription_plan_id == "null" || $subscription_plan_id == null) {
        // Add
        unset($request['operation']);
        $dateTime = date('Y-m-d H:i:s');

        $sql = "INSERT INTO `subscription_plan` SET ";
        $sql .= " `added_by` = :user_id,";
        $sql .= $request['status'] === 'true' ? " `status` = '1'," : " `status` = '0',";
        $sql .= " `date_added` = :date_added,";
        $sql .= " `sort` = :sort,";
        $sql .= " `price` = :price,";
        $sql .= " `duration_name` = :duration_name,";
        $sql .= " `duration` = :duration";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
        $stmt->bindParam(':date_added', $dateTime, PDO::PARAM_STR);
        $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_INT);
        $stmt->bindParam(':price', $request['price'], PDO::PARAM_STR);
        $stmt->bindParam(':duration_name', $request['duration_name'], PDO::PARAM_STR);
        $stmt->bindParam(':duration', $request['duration'], PDO::PARAM_STR);

        $stmt->execute();
        $last_subscription_plan_id = $this->mDb->connect()->lastInsertId();

        foreach ($newcategoryLangObj as $key => $value) {
            $stmt = "INSERT INTO `subscription_plan_langs`(`subscription_plan_id`, `lang_code`, `name`, `description`) ";
            $stmt .= "VALUES (:subscription_plan_id, :lang_code, :name, :description)";

            $stmt = $this->mDb->connect()->prepare($stmt);
            $stmt->bindParam(':subscription_plan_id', $last_subscription_plan_id, PDO::PARAM_INT);
            $stmt->bindParam(':lang_code', $value['lang_code'], PDO::PARAM_STR);
            $stmt->bindParam(':name', $value['name'], PDO::PARAM_STR);
            $stmt->bindParam(':description', $value['description'], PDO::PARAM_STR);

            $res = $stmt->execute();
        }

        return $res !== false;
    } else {
        // Edit
        $check_query = "SELECT `id` FROM `subscription_plan` WHERE `id` = :subscription_plan_id";
        $stmt = $this->mDb->connect()->prepare($check_query);
        $stmt->bindParam(':subscription_plan_id', $subscription_plan_id, PDO::PARAM_INT);
        $stmt->execute();
        $check_result = $stmt->fetch(PDO::FETCH_ASSOC);

        if ($check_result === false) {
            return "edit";
        } else {
            $sql = "UPDATE `subscription_plan` SET ";
            $sql .= " `added_by` = :user_id, ";
            $sql .= " `sort` = :sort, ";
            $sql .= "`price` = :price,";
            $sql .= "`duration` = :duration,";
            $sql .= " `duration_name` = :duration_name,";
            $sql .= $request['status'] === 'true' ? " `status` = '1'" : " `status` = '0'";
            $sql .= " WHERE `id` = :subscription_plan_id";

            $stmt = $this->mDb->connect()->prepare($sql);
            $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
            $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_INT);
            $stmt->bindParam(':price', $request['price'], PDO::PARAM_STR);
            $stmt->bindParam(':duration', $request['duration'], PDO::PARAM_STR);
            $stmt->bindParam(':duration_name', $request['duration_name'], PDO::PARAM_STR);
            $stmt->bindParam(':subscription_plan_id', $subscription_plan_id, PDO::PARAM_INT);

            $stmt->execute();

            foreach ($newcategoryLangObj as $key => $value) {
                $stmt = "UPDATE `subscription_plan_langs` SET";
                $stmt .= " `name`=:name, ";
                $stmt .= " `description`=:description ";
                $stmt .= " WHERE `lang_code`=:lang_code AND `subscription_plan_id`=:subscription_plan_id";

                $stmt = $this->mDb->connect()->prepare($stmt);
                $stmt->bindParam(':name', $value['name'], PDO::PARAM_STR);
                $stmt->bindParam(':description', $value['description'], PDO::PARAM_STR);
                $stmt->bindParam(':lang_code', $value['lang_code'], PDO::PARAM_STR);
                $stmt->bindParam(':subscription_plan_id', $subscription_plan_id, PDO::PARAM_INT);

                $res = $stmt->execute();
            }

            return $res !== false;
        }
    }
}
    
function deleteplanSubscription($id)
  {
    // (1,2,3,4,5,6)
    $subscription_plan_id = '(' . implode(',', $id) . ')';

    
    $sqll = "DELETE FROM `subscription_plan_langs` ";
    $sqll .= " WHERE `subscription_plan_id` IN " . $subscription_plan_id;

    $stmt = $this->mDb->connect()->prepare($sqll);
    $stmt->execute();

    $entitysql = "DELETE FROM `subscription_plan` ";
    $entitysql .= " WHERE `id` IN " . $subscription_plan_id;
    $stmt = $this->mDb->connect()->prepare($entitysql);
    
    
    if ($stmt->execute()){
        return true;
    }else
    {
        return false;
    }
   
  }


}
