<?php
// echo "test";
// die();
$trailDurationObj = new trailDuration();

class trailDuration {

    var $mDb; 
    var $mConfig; 
    var $mMailer;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();

    }
function convert_object_to_array($data) {
        if (is_object($data)) {
            $data = get_object_vars($data);
        }
        
        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            // echo "test"; die();
            return $data;
        }
    }
    
    
function getAlltrailDuration($start,$perpage,$lang_code, $searchName, $type, $sort) {
    // echo"test";
    // die();
        
         $result=array();
        
        $sql = "SELECT t.*, tl.membership_type , tl.lang_code, u.full_name as added_by FROM trail_duration t LEFT JOIN trail_duration_langs tl ON tl.trail_duration_id = t.id and tl.`lang_code`='{$lang_code}' LEFT JOIN users u ON t.added_by = u.id WHERE t.id > 0 ";

        if ($searchName) {
        $sql .= " AND tl.name LIKE :searchName"; 
                 }
        
        $sql .= " LIMIT " . (int)$start . ", " . (int)$perpage;
// echo $sql; die();
    
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            
            throw new Exception("Error preparing the SQL statement."); 
        }
        
        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        if ($searchName) {
            $searchName = '%' . $searchName . '%';
            $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
        }
         if (!$stmt->execute()) { 
             
            throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
        }
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC); // Fetch all results
   

    return $result;

        
    }
    
    
function gettrailDurationCount($searchName, $lang_code) {
    $sql = "SELECT COUNT(t.`id`) as 'count' FROM `trail_duration` t "
         . "LEFT JOIN `trail_duration_langs` tl ON t.`id` = tl.`trail_duration_id` "
         . "WHERE t.`id` > 0 AND tl.`lang_code` = :lang_code ";

    $params = array(':lang_code' => $lang_code);

    if ($searchName) {
        $sql .= "AND tl.`name` LIKE :searchName ";
        $params[':searchName'] = '%' . $searchName . '%';
    }

    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->execute($params);
    $result = $stmt->fetchColumn();

    return $result;
}
    
function addEdittrailDuration($request, $trail_duration_id) {
    $categoryLangObj = json_decode($request['langs']);
    $newcategoryLangObj = $this->convert_object_to_array($categoryLangObj);
    $res = false;

    if (!$trail_duration_id || $trail_duration_id == "null" || $trail_duration_id == null) {
        // Add
          unset($request['operation']);
    $dateTime = date('Y-m-d H:i:s');

    $sql = "INSERT INTO trail_duration SET ";
    $sql .= "added_by = :user_id, ";
    $sql .= "date_added = :date_added, ";
    $sql .= "sort = :sort, ";
    $sql .= "duration = :duration ";

    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
    $stmt->bindParam(':date_added', $dateTime, PDO::PARAM_STR);
    $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_INT);
    $stmt->bindParam(':duration', $request['duration'], PDO::PARAM_STR);

    if (!$stmt->execute()) { 
        throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
    }
           $last_trail_duration_id = $this->mDb->getLastInsertId();

    foreach ($newcategoryLangObj as $key => $value) {
        $query = "INSERT INTO trail_duration_langs (trail_duration_id, lang_code, membership_type) ";
        $query .= "VALUES (:trail_duration_id, :lang_code, :membership_type)";
        
        $stmt = $this->mDb->connect()->prepare($query);
        $stmt->bindParam(':trail_duration_id', $last_trail_duration_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $value['lang_code'], PDO::PARAM_STR);
        $stmt->bindParam(':membership_type', $value['membership_type'], PDO::PARAM_STR);
       
        $stmt->execute();
    }

    return $stmt->rowCount() > 0;


        

       
    }else {
    // Edit
    $check_query = "SELECT `id` FROM `trail_duration` WHERE `id` = :trail_duration_id";

    $stmt = $this->mDb->connect()->prepare($check_query);
    $stmt->bindParam(':trail_duration_id', $trail_duration_id, PDO::PARAM_INT);
    $stmt->execute();
    $check_result = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($stmt->rowCount() === 0) {
        return "edit";
    } else {
        $sql = "UPDATE `trail_duration` SET ";
        $sql .= " `added_by` = :user_id, ";
        $sql .= " `sort` = :sort, ";
        $sql .= " `duration` = :duration ";
        $sql .= " WHERE `id` = :trail_duration_id";

        $stmt = $this->mDb->connect()->prepare($sql);
        $stmt->bindParam(':user_id', $request['user_id'], PDO::PARAM_INT);
        $stmt->bindParam(':sort', $request['sort'], PDO::PARAM_INT);
        $stmt->bindParam(':duration', $request['duration'], PDO::PARAM_STR);
        $stmt->bindParam(':trail_duration_id', $trail_duration_id, PDO::PARAM_INT);

        $stmt->execute();

        $success = true;

        foreach ($newcategoryLangObj as $key => $value) {
            $query = "UPDATE `trail_duration_langs` SET ";
            $query .= " `membership_type` = :membership_type ";
            $query .= " WHERE `lang_code` = :lang_code AND `trail_duration_id` = :trail_duration_id";

            $stmt = $this->mDb->connect()->prepare($query);
            $stmt->bindParam(':membership_type', $value['membership_type'], PDO::PARAM_STR);
            $stmt->bindParam(':lang_code', $value['lang_code'], PDO::PARAM_STR);
            $stmt->bindParam(':trail_duration_id', $trail_duration_id, PDO::PARAM_INT);

            if (!$stmt->execute()) {
                $success = false;
                break;
            }
        }

        return $success;
    }
}
}
function deletetrailDuration($id)
  {
    // (1,2,3,4,5,6)
    $trail_duration_id = '(' . implode(',', $id) . ')';

    
    $sqll = "DELETE FROM `trail_duration_langs` ";
    $sqll .= " WHERE `trail_duration_id` IN " . $trail_duration_id;

    $stmt = $this->mDb->connect()->prepare($sqll);
    $stmt->execute();
    
    $trail_durationsql = "DELETE FROM `trail_duration` ";
    $trail_durationsql .= " WHERE `id` IN " . $trail_duration_id;

    $stmt = $this->mDb->connect()->prepare($trail_durationsql);
    
    
    if ($stmt->execute()){
        return true;
    }else
    {
        return false;
    }
  }
    

  
  

}
