<?php

$userAdmObj = new users();

class users {

var $mDb; 
var $mConfig;
var $notificate;

function __construct() {
    global $Config; 
    $this -> mDb = new iplus(); 
    $this -> mConfig = $Config;
    $this->notificate = new pushmessage();
}

function convert_object_to_array($data) {

// print_r($data);die();
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }
    
function getUserLevel($request) {

    $user_id = $request['user_id'];
    $roles = $request['roles'];

    $select = implode(", ", $roles);

    $query = "SELECT u.`id` AS 'user_id_in_users', {$select} FROM `users` u";
    $query .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
    $query .= " WHERE u.`id` = '{$user_id}' ";
    // echo $query; die();
    return $this -> mDb -> getRow($query);
}    
function getUsersLevels($leveltype,$provider_id) {
    $sql = "SELECT `id`, `level_name` FROM `user_levels` ";
//    $sql .= $leveltype == 'provider' ?" AND `provider_id` = '$provider_id' ":"";

    return $this -> mDb -> getAll($sql); 
}
function login($email, $password, $dial_code = null, $country_symbol = null) {
    $result = array();

    // Determine if the login is via email or mobile
    $is_mobile = preg_match('/^[0-9]+$/', $email);
    if ($dial_code && $country_symbol) {
        // Login via mobile
        $sql = "SELECT `id`, `password` FROM `users` WHERE `mobile` = :email AND `dial_code` = :dial_code AND `country_symbol` = :country_symbol";
    } else {
        // Login via email
        $sql = "SELECT `id`, `password` FROM `users` WHERE `email` = :email";
    }


    try {
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for login.");
        }

        if ($is_mobile && $dial_code && $country_symbol) {
            $stmt->bindParam(':email', $email, PDO::PARAM_STR);
            $stmt->bindParam(':dial_code', $dial_code, PDO::PARAM_STR);
            $stmt->bindParam(':country_symbol', $country_symbol, PDO::PARAM_STR);
        } else {
            $stmt->bindParam(':email', $email, PDO::PARAM_STR);
        }

        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

         if ($result) {
            $hashedPassword = $result['password'];

            // Verify the password
            $login = password_verify($password, $hashedPassword);

            if (password_verify($result['password'],$password)) {
                echo $password ."====".$hashedPassword."====".$login;
            // print_r($sql);
            die();
                $check_query = "SELECT u.id, u.qr_code, u.entity_id, u.type, u.email, u.authentication_code, u.mobile, u.full_name, u.img, cm.membership_id, cm.card_img, c.licence, c.car_licence, c.membership_type
                                FROM `users` u
                                LEFT JOIN `clubs_members` cm ON u.`id` = cm.`user_id`
                                LEFT JOIN `captains` c ON u.`id` = c.`user_id`
                                WHERE u.`id` = :id";

                $stmt = $this->mDb->connect()->prepare($check_query);

                if (!$stmt) {
                    throw new Exception("Error preparing the SQL statement for user data retrieval.");
                }

                $stmt->bindParam(':id', $result['id'], PDO::PARAM_INT);
                $stmt->execute();
                $userData = $stmt->fetch(PDO::FETCH_ASSOC);

                return $userData;
            } else {
                return false; // Password verification failed
            }
        } else {
            return false; // User not found
        }
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}

/////////////////////////////////////// Admins ///////////////////////////////////////////////
function getUsersSubscription($id) {
    // echo $id;
    // die();
    $check_query = "SELECT ms.start_date, ms.end_date FROM member_subscription ms WHERE ms.user_id = :id";
    
    $stmt = $this->mDb->connect()->prepare($check_query);
    $stmt->bindParam(':id', $id, PDO::PARAM_INT);
    $stmt->execute();
    // print_r($stmt);
    // die();
    
    return $stmt->fetch(PDO::FETCH_ASSOC);
}


function getSomeUsers($userType, $aStart, $aLimit, $sort, $type, $searchUserMemberShipID, $searchName, $searchUserPhone, $searchStartDate, $searchEndDate, $searchUserStatus, $searchUserType) {
    $sql = "SELECT cm.*, c.*, u.*, u.full_name as added_by FROM `users` u";
    $sql .= " LEFT JOIN `user_levels` ul ON ul.id = u.user_level ";
    $sql .= " LEFT JOIN captains c ON c.user_id = u.id ";
    $sql .= " LEFT JOIN clubs_members cm ON cm.user_id = u.id ";
    $sql .= " WHERE u.id > 0 ";
    
    if ($searchName) {
        $sql .= " AND u.full_name LIKE :searchName";
    }
    
    if ($searchUserPhone) {
        $sql .= " AND u.mobile LIKE :searchUserPhone";
    }
    
    if ($searchUserMemberShipID) {
        $sql .= " AND cm.membership_id LIKE :searchUserMemberShipID";
    }
    
    if ($searchStartDate) {
        $sql .= " AND cm.start_date LIKE :searchStartDate";
    }
    
    if ($searchEndDate) {
        $sql .= " AND cm.end_date LIKE :searchEndDate";
    }
    
    if ($searchUserStatus) {
        $sql .= " AND u.status LIKE :searchUserStatus";
    }
    
    if ($searchUserType) {
        $sql .= " AND u.type LIKE :searchUserType";
    }
    
    $sql .= " ORDER BY u.{$sort} {$type}";
    
    if ($aLimit) {
        $sql .= " LIMIT :aStart, :aLimit";
    }
    
    $stmt = $this->mDb->connect()->prepare($sql);
    
    if ($searchName) {
        $searchName = '%' . $searchName . '%';
        $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
    }
    
    if ($searchUserPhone) {
        $searchUserPhone = '%' . $searchUserPhone . '%';
        $stmt->bindParam(':searchUserPhone', $searchUserPhone, PDO::PARAM_STR);
    }
    
    if ($searchUserMemberShipID) {
        $searchUserMemberShipID = '%' . $searchUserMemberShipID . '%';
        $stmt->bindParam(':searchUserMemberShipID', $searchUserMemberShipID, PDO::PARAM_STR);
    }
    
    if ($searchStartDate) {
        $searchStartDate = '%' . $searchStartDate . '%';
        $stmt->bindParam(':searchStartDate', $searchStartDate, PDO::PARAM_STR);
    }
    
    if ($searchEndDate) {
        $searchEndDate = '%' . $searchEndDate . '%';
        $stmt->bindParam(':searchEndDate', $searchEndDate, PDO::PARAM_STR);
    }
    
    if ($searchUserStatus) {
        $searchUserStatus = '%' . $searchUserStatus . '%';
        $stmt->bindParam(':searchUserStatus', $searchUserStatus, PDO::PARAM_STR);
    }
    
    if ($searchUserType) {
        $searchUserType = '%' . $searchUserType . '%';
        $stmt->bindParam(':searchUserType', $searchUserType, PDO::PARAM_STR);
    }
    
    if ($aLimit) {
        $stmt->bindParam(':aStart', $aStart, PDO::PARAM_INT);
        $stmt->bindParam(':aLimit', $aLimit, PDO::PARAM_INT);
    }
    
    if (!$stmt->execute()) {
        throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
    }
    
    return $stmt->fetchAll(PDO::FETCH_ASSOC);
}
function getAllDetailsUserData($id){
        $check_query = "SELECT u.*, cm.*, c.*
                        FROM `users` u
                        LEFT JOIN `clubs_members` cm ON u.`id` = cm.`user_id`
                        LEFT JOIN `captains` c ON u.`id` = c.`user_id`
                        WHERE u.`id` = {$id}";
       
  
        // $check_query .= $request['userType'] === "admins" ? " AND `user_level` IS NOT NULL" : "";
        return $this -> mDb -> getRow($check_query);
    
    
}
function getUsersCount($searchUserMemberShipID, $searchName, $searchUserPhone, $searchStartDate, $searchEndDate, $searchUserStatus, $searchUserType) {
    $sql = "SELECT COUNT(u.`id`) as 'count' FROM `users` u";
    $sql .= " LEFT JOIN captains c ON c.user_id = u.id ";
    $sql .= " LEFT JOIN clubs_members cm ON cm.user_id = u.id ";
    $sql .= " WHERE u.id > 0 ";
    if ($searchName) {
        $sql .= " AND u.full_name LIKE :searchName";
    }
    
    if ($searchUserPhone) {
        $sql .= " AND u.mobile LIKE :searchUserPhone";
    }
    
    if ($searchUserMemberShipID) {
        $sql .= " AND cm.membership_id LIKE :searchUserMemberShipID";
    }
    
    if ($searchStartDate) {
        $sql .= " AND cm.start_date LIKE :searchStartDate";
    }
    
    if ($searchEndDate) {
        $sql .= " AND cm.end_date LIKE :searchEndDate";
    }
    
    if ($searchUserStatus) {
        $sql .= " AND u.status LIKE :searchUserStatus";
    }
    
    if ($searchUserType) {
        $sql .= " AND u.type LIKE :searchUserType";
    }
    $stmt = $this->mDb->connect()->prepare($sql);
    
    if ($searchName) {
        $searchName = '%' . $searchName . '%';
        $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
    }
    
    if ($searchUserPhone) {
        $searchUserPhone = '%' . $searchUserPhone . '%';
        $stmt->bindParam(':searchUserPhone', $searchUserPhone, PDO::PARAM_STR);
    }
    
    if ($searchUserMemberShipID) {
        $searchUserMemberShipID = '%' . $searchUserMemberShipID . '%';
        $stmt->bindParam(':searchUserMemberShipID', $searchUserMemberShipID, PDO::PARAM_STR);
    }
    
    if ($searchStartDate) {
        $searchStartDate = '%' . $searchStartDate . '%';
        $stmt->bindParam(':searchStartDate', $searchStartDate, PDO::PARAM_STR);
    }
    
    if ($searchEndDate) {
        $searchEndDate = '%' . $searchEndDate . '%';
        $stmt->bindParam(':searchEndDate', $searchEndDate, PDO::PARAM_STR);
    }
    
    if ($searchUserStatus) {
        $searchUserStatus = '%' . $searchUserStatus . '%';
        $stmt->bindParam(':searchUserStatus', $searchUserStatus, PDO::PARAM_STR);
    }
    
    if ($searchUserType) {
        $searchUserType = '%' . $searchUserType . '%';
        $stmt->bindParam(':searchUserType', $searchUserType, PDO::PARAM_STR);
    }
    
   
    
    if (!$stmt->execute()) {
        throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
    }
    
    return $stmt->fetch(PDO::FETCH_ASSOC)['count'];
    
}

function getOneUser($userType, $id) {


    $result = array();

      try {
        
        $sql = "SELECT u.`id`, u.`email`, u.`full_name`, u.`mobile`, u.`img`, u.`user_level`, u.`type`, u.`notes`, u.`status`, u.`date_added` 
                FROM `users` u 
                LEFT JOIN `user_levels` ul ON ul.id = u.user_level 
                WHERE u.`id` = :id";

        if ($userType === "admin") {
            $sql .= " AND u.`user_level` IS NOT NULL AND u.`type` IS NULL";
        }

        // Prepare the statement
        $stmt = $this->mDb->connect()->prepare($sql);

        // Bind the parameter
        $stmt->bindParam(':id', $id, PDO::PARAM_INT);

        // Execute the statement
        $stmt->execute();

        // Fetch the result
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

    } catch (PDOException $e) {
        // Handle any errors
        echo 'Connection failed: ' . $e->getMessage();
    }

    // Return the result
    return $result;
}

function getClubMemberCount() {
    $sql = "SELECT COUNT(`id`) as count FROM `clubs_members`";
    $stmt = $this->mDb->prepare($sql);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($result && isset($result['count'])) {
        return $result['count'];
    }

    return 0;
}
function getUserScanInfo($user_id, $entity_id, $lang_code) {
    
    // echo "tst";
    // die();
        $sql = "SELECT u.email, u.full_name, u.mobile, u.img, ms.entity_id, ms.plan_type, ms.start_date, ms.end_date 
                FROM users u
                LEFT JOIN member_subscription ms ON u.id = ms.user_id
                LEFT JOIN entities e ON e.id = ms.entity_id
                LEFT JOIN entities_langs el ON el.entity_id = e.id
                WHERE u.id = :user_id AND el.lang_code = :lang_code AND e.id = :entity_id";
        // print_r($sql);
        // die();
        
        // Prepare the SQL statement
        $stmt = $this->mDb->connect()->prepare($sql);
        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for retrieving user scan info.");
        }

        // Bind parameters
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':entity_id', $entity_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);

        // Execute the query
        $stmt->execute();
        // Fetch the results
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        return $result;
        

}

function addEditUser($request, $temp, $user_id)
{
    unset($request['action']);
    $userstypeObj = json_decode($request['type_data']);
    $newUserstypeObj = $this->convert_object_to_array($userstypeObj);

    $pdo = $this->mDb->connect(); // Assuming you have a PDO object available
    $dateTime = date('Y-m-d H:i:s');
    $res = false;

    try {
        if (empty($user_id)) {
            // Add new user
            unset($request['operation']);
            $request['password'] = password_hash($request['password'], PASSWORD_DEFAULT);

            $sql = "INSERT INTO `users` (`full_name`, `email`, `dial_code`, `mobile`, `country_symbol`, `password`, `type`, `entity_id`, `added_by`, `user_level`, `img`, `date_added`, `notes`, `status`) 
                    VALUES (:full_name, :email, :dial_code, :mobile, :country_symbol, :password, :type, :entity_id, :added_by, :user_level, :img, :date_added, :notes, :status)";
            $stmt = $pdo->prepare($sql);

            $stmt->bindParam(':full_name', $request['full_name']);
            $stmt->bindParam(':email', $request['email']);
            $stmt->bindParam(':dial_code', $request['dial_code']);
            $stmt->bindParam(':mobile', $request['mobile']);
            $stmt->bindParam(':country_symbol', $request['country_symbol']);
            $stmt->bindParam(':password', $request['password']);
            $stmt->bindParam(':type', $request['type']);
            $stmt->bindParam(':notes', $request['notes']);
            $stmt->bindParam(':status', $request['status']);
            $stmt->bindParam(':entity_id', $request['entity_id']);
            $stmt->bindParam(':added_by', $request['added_by']);
            $stmt->bindParam(':user_level', $request['user_level']);
            $stmt->bindParam(':img', $temp['img']);
            $stmt->bindParam(':date_added', $dateTime);

            if (!$stmt->execute()) {
                throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
            }

            $id = $pdo->lastInsertId();

            if ($request['type'] == "club_member" && $id) {
                $stmt = $pdo->prepare("INSERT INTO `clubs_members` (`user_id`, `membership_id`, `start_date`, `end_date`, `card_img`) VALUES (:user_id, :membership_id, :start_date, :end_date, :card_img)");
                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':membership_id', $request['membership_id']);
                $stmt->bindParam(':start_date', $request['start_date']);
                $stmt->bindParam(':end_date', $request['end_date']);
                $stmt->bindParam(':card_img', $temp['card_img']);
                $res = $stmt->execute();
            } elseif (($request['type'] == "captain" && $id) || ($request['type'] == "delivery" && $id)) {
                $stmt = $pdo->prepare("INSERT INTO `captains` (`user_id`, `membership_type`, `licence`, `car_licence`) VALUES (:user_id, :membership_type, :licence, :car_licence)");
                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':membership_type', $request['membership_type']);
                $stmt->bindParam(':licence', $temp['licence']);
                $stmt->bindParam(':car_licence', $temp['car_licence']);
                $res = $stmt->execute();
            }

            return $res == "" ? $id : $res;
        } else {
            // Update existing user
            $sql = "UPDATE `users` SET 
                        `full_name` = :full_name, 
                        `email` = :email, 
                        `dial_code` = :dial_code,
                        `mobile` = :mobile, 
                        `country_symbol` = :country_symbol,
                        `password` = :password, 
                        `type` = :type, 
                        `entity_id` = :entity_id, 
                        `added_by` = :added_by, 
                        `user_level` = :user_level, 
                        `img` = :img, 
                        `date_added` = :date_added, 
                        `notes` = :notes, 
                        `status` = :status 
                    WHERE `id` = :id";
            $stmt = $pdo->prepare($sql);

            $stmt->bindParam(':full_name', $request['full_name']);
            $stmt->bindParam(':email', $request['email']);
            $stmt->bindParam(':dial_code', $request['dial_code']);
            $stmt->bindParam(':mobile', $request['mobile']);
            $stmt->bindParam(':country_symbol', $request['country_symbol']);
            $hashedPassword = password_hash($request['password'], PASSWORD_DEFAULT);
            $stmt->bindParam(':password', $hashedPassword);
            $stmt->bindParam(':type', $request['type']);
            $stmt->bindParam(':entity_id', $request['entity_id']);
            $stmt->bindParam(':added_by', $request['added_by']);
            $stmt->bindParam(':user_level', $request['user_level']);
            $stmt->bindParam(':img', $temp['img']);
            $stmt->bindParam(':date_added', $dateTime);
            $stmt->bindParam(':notes', $request['notes']);
            $stmt->bindParam(':status', $request['status']);
            $stmt->bindParam(':id', $request['id']); // Assuming the ID is provided in $request['id']

            if (!$stmt->execute()) {
                throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
            }

            $res = $stmt->rowCount() > 0;

            if ($res) {
                if ($request['type'] == "club_member") {
                    $stmt = $pdo->prepare("UPDATE `clubs_members` SET 
                                                `membership_id` = :membership_id, 
                                                `start_date` = :start_date, 
                                                `end_date` = :end_date, 
                                                `card_img` = :card_img 
                                            WHERE `user_id` = :user_id");
                    $stmt->bindParam(':membership_id', $request['membership_id']);
                    $stmt->bindParam(':start_date', $request['start_date']);
                    $stmt->bindParam(':end_date', $request['end_date']);
                    $stmt->bindParam(':card_img', $temp['card_img']);
                    $stmt->bindParam(':user_id', $user_id);
                    $res = $stmt->execute();
                } elseif ($request['type'] == "captain" || $request['type'] == "delivery") {
                    $stmt = $pdo->prepare("UPDATE `captains` SET 
                                                `membership_type` = :membership_type, 
                                                `licence` = :licence, 
                                                `car_licence` = :car_licence 
                                            WHERE `user_id` = :user_id");
                    $stmt->bindParam(':membership_type', $request['membership_type']);
                    $stmt->bindParam(':licence', $temp['licence']);
                    $stmt->bindParam(':car_licence', $temp['car_licence']);
                    $stmt->bindParam(':user_id', $user_id);
                    $res = $stmt->execute();
                }
            }

            return $res;
        }
    } catch (Exception $e) {
        error_log($e->getMessage());
        echo "Exception: " . $e->getMessage();
        return false;
    } catch (PDOException $e) {
        error_log($e->getMessage());
        echo $e->getMessage();
        return false;
    }
}

function addQRCode($user_id, $name){
    // $qrCodePathInDb = 'qr_codes' . $user_id . '.png';
    
     $sql = " UPDATE `users` SET `qr_code` = '{$name}' WHERE `id` = '{$user_id}' ";
    //  echo $sql;die();
     
     return $this->mDb->query($sql);
}
function getUserDataFromQRCode($user_id){
    
    // Perform a database query to fetch the user data
    $sql = "SELECT u.*, ms.* FROM `users` u ";
    $sql .= "LEFT JOIN `member_subscription` ms ON ms.added_by = u.id ";
    $sql .= "WHERE u.id = '{$user_id}'";
    
    // echo $sql; die();
    return $this -> mDb -> getAll($sql); 
}
function addQrcodeHistoryInfo($user_id, $entity_id, $added_by) {
    try {
        $sql = "INSERT INTO qrcodehistory_info (entity_id, added_by, user_id) VALUES (:entity_id, :added_by, :user_id)";
        
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for adding QR code history info.");
        }

        $stmt->bindParam(':entity_id', $entity_id, PDO::PARAM_INT);
        $stmt->bindParam(':added_by', $added_by, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();

        return true;
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}
function getQrcodeHistoryInfo($searchName, $searchUserMemberShipID, $searchDateFrom, $searchDateTo, $user_id, $entity_id) {
    try {
        $sql = "SELECT cm.membership_id, u.full_name, uu.full_name AS keeper, u.mobile, el.name, qr.*
                FROM qrcodehistory_info qr
                LEFT JOIN clubs_members cm ON cm.user_id = qr.user_id
                LEFT JOIN entities_langs el ON (el.entity_id = qr.entity_id AND el.lang_code = 'ar')
                LEFT JOIN users u ON u.id = qr.user_id
                LEFT JOIN users uu ON uu.id = qr.added_by
                WHERE qr.id > 0 AND (qr.added_by = :user_id OR qr.entity_id = :entity_id)";
                
        $params = array(
            'user_id' => $user_id,
            'entity_id' => $entity_id
        );
        
        if ($searchName) {
            $sql .= " AND u.full_name LIKE :searchName";
            $params['searchName'] = '%' . $searchName . '%';
        }
        if ($searchDateFrom && $searchDateTo) {
            $sql .= " AND qr.date_added BETWEEN :searchDateFrom AND :searchDateTo";
            $params['searchDateFrom'] = $searchDateFrom;
            $params['searchDateTo'] = $searchDateTo;
        }
        if ($searchUserMemberShipID) {
            $sql .= " AND cm.membership_id LIKE :searchUserMemberShipID";
            $params['searchUserMemberShipID'] = '%' . $searchUserMemberShipID . '%';
        }
        
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for retrieving QR code history info.");
        }

        foreach ($params as $paramKey => $paramValue) {
            $stmt->bindParam(':' . $paramKey, $paramValue, PDO::PARAM_STR);
        }
        
        $stmt->execute();
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

        return $result;
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}
function getQrcodeHistorycount() {
    $sql = "SELECT COUNT(`id`) as count FROM `qrcodehistory_info`";
    $stmt = $this->mDb->prepare($sql);
    $stmt->execute();
    $result = $stmt->fetch(PDO::FETCH_ASSOC);

    if ($result && isset($result['count'])) {
        return $result['count'];
    }

    return 0;
}
function deleteUser($ids) {
 $tempids = '(' . implode(',', $ids) . ')';
    // echo $tempids;die();
    $sql = "SELECT `img` FROM `users`";
    $sql .= " WHERE `id` IN $tempids";

try {
    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->execute();
    $result = $stmt->fetchAll(PDO::FETCH_ASSOC);
     $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/' . $result['img'];
            if (file_exists($old_img)) {
                @unlink($old_img);
            }
} catch (PDOException $e) {
    // Handle any database errors
    echo "Error: " . $e->getMessage();
    return false;
    }

    //  echo $stmt;
    //  die();
    // return $result;
    // print_r ($result[0]['img']);die();
    
    $usersql = "DELETE FROM `users` ";
    $usersql .= " WHERE `id` IN  $tempids";
    $stmt = $this->mDb->prepare($usersql);
    
    $usersqll = "DELETE FROM `clubs_members` ";
    $usersqll .= " WHERE `user_id` IN $tempids";
    $stmtsql = $this->mDb->prepare($usersqll);
    

    $userslicenceqllp = "DELETE FROM `captains` ";
    $userslicenceqllp .= " WHERE `user_id` IN  $tempids";
    $stmtuserslicenceqllp = $this->mDb->prepare($userslicenceqllp);
   

    $usersqllp = "DELETE FROM `captains` ";
    $usersqllp .= " WHERE `user_id` IN $tempids";
    $stmtusersqllp = $this->mDb->prepare($usersqllp);
    

    
        $card_imgsql = "SELECT `card_img` FROM `clubs_members`";
        $card_imgsql .= " WHERE `user_id` IN  $tempids";
        
        try {
            $stmtcard_imgsql = $this->mDb->connect()->prepare($card_imgsql);
            $stmtcard_imgsql->execute();
            $result = $stmtcard_imgsql->fetchAll(PDO::FETCH_ASSOC);
             $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/' . $result['card_img'];
            if (file_exists($old_img)) {
                @unlink($old_img);
            }
            
        } catch (PDOException $e) {
            // Handle any database errors
            echo "Error: " . $e->getMessage();
            return false;
            }
            
        $licencesql = "SELECT `licence` FROM `captains`";
        $licencesql .= " WHERE `user_id` IN $tempids";
        
        
        try {
            $stmtlicencesql = $this->mDb->connect()->prepare($licencesql);
            $stmtlicencesql->execute();
            $result = $stmtlicencesql->fetchAll(PDO::FETCH_ASSOC);
              $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/' . $result['licence'];
            if (file_exists($old_img)) {
                @unlink($old_img);
            }
        } catch (PDOException $e) {
            // Handle any database errors
            echo "Error: " . $e->getMessage();
            return false;
            }

        

   
        $carlicencesql = "SELECT `car_licence` FROM `captains`";
        $carlicencesql .= " WHERE `user_id` IN  $tempids";
        
        
         try {
            $stmtcarlicencesql = $this->mDb->connect()->prepare($carlicencesql);
            $stmtcarlicencesql->execute();
            $result = $stmtcarlicencesql->fetchAll(PDO::FETCH_ASSOC);
            $old_img = $_SERVER['DOCUMENT_ROOT'] . '/' . $this->mConfig['uploads_path'] . 'users/' . $result['car_licence'];
            if (file_exists($old_img)) {
                @unlink($old_img);
            }
        } catch (PDOException $e) {
            // Handle any database errors
            echo "Error: " . $e->getMessage();
            return false;
            }

        
            
                
    return true;

}
function insertAuthCode($aId, $authentication_code) {
    $sql = " UPDATE `users` SET `authentication_code` = '{$authentication_code}'";
    $sql.= " WHERE `id` = '{$aId}'";
    // echo $sql; die();
    return $this->mDb->query($sql);
}
function getSearchUsersByType($user_type) {
    $result = array();
    $sql = "SELECT u.`id`, u.`full_name`, u.`img` FROM `users` u";
    $sql .= " WHERE u.`id` >0 AND u.`user_type` ='{$user_type}'";
   
    // echo $sql;die();
    $result=$this -> mDb -> getAll($sql);
    return  $result;
}
function getUsersCountByType($userType) {
 
    // echo $userType;
 $sql = "SELECT COUNT(`id`) as count FROM `users`";
 $sql .= " WHERE `user_type` = :userType";
 
    $stmt = $this->mDb->connect()->prepare($sql);
    $stmt->bindParam(':userType', $userType);
    $stmt->execute();
    // print_r($stmt);
    $result = $stmt->fetch(PDO::FETCH_ASSOC);
    

    if ($result && isset($result['count'])) {
        return $result['count'];
    }

    return 0;    
}





}?>