<?php
// echo "test";
// die();
$entityObj = new Entity();

class Entity {

    var $mDb; 
    var $mConfig; 
    var $mMailer;

    function __construct() {
        global $Config; 
        $this->mDb = new iplus(); 
        $this->mConfig = $Config; 
        $this->mMailer = new Mailer();

    }

    
  function getAllEntities($start, $perpage, $lang_code, $searchName = null, $type = null) {
    $result = array();

    $sql = "SELECT e.*, el.name, el.description, el.lang_code, u.full_name AS admin_name 
            FROM entities e
            LEFT JOIN entities_langs el ON el.entity_id = e.id AND el.lang_code = :lang_code
            LEFT JOIN users u ON e.added_by = u.id
            WHERE e.id > 0 "; 

    if ($searchName) {
        $sql .= " AND el.name LIKE :searchName"; 
    }

    if ($type) {
        $sql .= " AND e.type LIKE :type"; 
    }

    // Remove single quotes around limit placeholders
        $sql .= " LIMIT " . (int)$start . ", " . (int)$perpage;
// echo $sql; die();
    
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            
            throw new Exception("Error preparing the SQL statement."); 
        }

        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        if ($searchName) {
            $searchName = '%' . $searchName . '%';
            $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
        }
        if ($type) {
            $type = '%' . $type . '%';
            $stmt->bindParam(':type', $type, PDO::PARAM_STR); 
        }

        // Make sure the limit parameters are bound as integers

        // $stmt->bindParam(':start', $start, PDO::PARAM_STR); 
        // $stmt->bindParam(':perpage', $perpage, PDO::PARAM_STR);
        
        if (!$stmt->execute()) { 
             
            throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
        }
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC); // Fetch all results
   

    return $result;
}


function getEntitiesCount($searchName = null, $lang_code, $type = null) {
    $count = 0; 

    // 1. Build the SQL Query Dynamically (with placeholders)
    $sql = "SELECT COUNT(e.id) AS count 
            FROM entities e
            LEFT JOIN entities_langs el ON e.id = el.entity_id 
            WHERE e.id > 0 AND el.lang_code = :lang_code";

    if ($searchName) {
        $sql .= " AND el.name LIKE :searchName"; 
    }

    if ($type) {
        $sql .= " AND e.type LIKE :type";
    }

    // 2. Prepare and Execute with Error Handling
    try {
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for count.");
        }

        // Bind parameters (adding wildcards for LIKE)
        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        if ($searchName) {
            $searchName = '%' . $searchName . '%';
            $stmt->bindParam(':searchName', $searchName, PDO::PARAM_STR);
        }
        if ($type) {
            $type = '%' . $type . '%';
            $stmt->bindParam(':type', $type, PDO::PARAM_STR);
        }

        $stmt->execute();
        $count = (int)$stmt->fetchColumn(); // Fetch the count directly as an integer
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error (Count): " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error (Count): " . $e->getMessage());
    }
    return $count;
}

    

}
