<?php

$userAdmObj = new users();

class users {

var $mDb; 
var $mConfig;
var $notificate;

function __construct() {
    global $Config; 
    $this -> mDb = new iplus(); 
    $this -> mConfig = $Config;
    $this->notificate = new pushmessage();
}

function convert_object_to_array($data) {

// print_r($data);die();
        if (is_object($data)) {
            $data = get_object_vars($data);
        }

        if (is_array($data)) {
            return array_map(__METHOD__, $data);
        }
        else {
            return $data;
        }
    }

function login($email, $password) {
    $result = array();

    $sql = "SELECT `id`, `password` FROM `users` ";
    $sql .= "WHERE (`email` = :email OR `mobile` = :email)";

    try {
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for login.");
        }

        $stmt->bindParam(':email', $email, PDO::PARAM_STR);
        $stmt->execute();
        $result = $stmt->fetch(PDO::FETCH_ASSOC);

        if (count($result) > 0) {
            $login = password_verify($password, $result['password']);

            if ($login === true) {
                $check_query = "SELECT u.id, u.qr_code, u.entity_id, u.type, u.email, u.mobile, u.full_name, u.img, cm.membership_id, cm.card_img, c.licence, c.car_licence, c.membership_type
                                FROM `users` u
                                LEFT JOIN `clubs_members` cm ON u.`id` = cm.`user_id`
                                LEFT JOIN `captains` c ON u.`id` = c.`user_id`
                                WHERE (u.`email` = :email OR u.`mobile` = :email)";

                $stmt = $this->mDb->connect()->prepare($check_query);

                if (!$stmt) {
                    throw new Exception("Error preparing the SQL statement for user data retrieval.");
                }

                $stmt->bindParam(':email', $email, PDO::PARAM_STR);
                $stmt->execute();
                $userData = $stmt->fetch(PDO::FETCH_ASSOC);

                return $userData;
            }
        }
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}

/////////////////////////////////////// Admins ///////////////////////////////////////////////
function getusersSubscription($id) {
    if ($id) {
        $check_query = "SELECT ms.start_date, ms.end_date 
                        FROM `member_subscription` ms 
                        WHERE ms.`user_id` = :id";

        try {
            $stmt = $this->mDb->connect()->prepare($check_query);

            if (!$stmt) {
                throw new Exception("Error preparing the SQL statement for user subscription data retrieval.");
            }

            $stmt->bindParam(':id', $id, PDO::PARAM_INT);
            $stmt->execute();
            $subscriptionData = $stmt->fetch(PDO::FETCH_ASSOC);

            return $subscriptionData;
        } catch (PDOException $e) {
            // Log the error for debugging
            throw new Exception("Database Error: " . $e->getMessage());
        } catch (Exception $e) {
            // Log the error
            throw new Exception("Error: " . $e->getMessage());
        }
    }
}

function getAllDetailsUserData($id){
        $check_query = "SELECT u.*, cm.*, c.*
                        FROM `users` u
                        LEFT JOIN `clubs_members` cm ON u.`id` = cm.`user_id`
                        LEFT JOIN `captains` c ON u.`id` = c.`user_id`
                        WHERE u.`id` = {$id}";
       
  
        // $check_query .= $request['userType'] === "admins" ? " AND `user_level` IS NOT NULL" : "";
        return $this -> mDb -> getRow($check_query);
    
    
}

function getClubMemberCount() {
    $sql = "SELECT COUNT(`id`) as 'count' FROM `clubs_members`";
    
    return $this -> mDb -> getOne($sql); 
}
function addEditUser($request, $temp, $user_id, $type)
{
    unset($request['action']);

    $userstypeObj = json_decode($request['type_data']);
    $newUserstypeObj = $this->convert_object_to_array($userstypeObj);

    $pdo = $this->mDb->connect(); // Assuming you have a PDO object available
    $dateTime = date('Y-m-d H:i:s');
    $res = false;

    try {
        if ($user_id == '' && $request['operation'] === 'add') {
            // Add
            unset($request['operation']);
            $request['password'] = password_hash($request['password'], PASSWORD_DEFAULT);

            $sql = "INSERT INTO `users` (`full_name`, `email`, `mobile`, `password`, `type`, `entity_id`, `added_by`, `user_level`, `img`, `date_added`";
            $sqlValues = "VALUES (:full_name, :email, :mobile, :password, :type, :entity_id, :added_by, :user_level, :img, :date_added";

            $stmt = $pdo->prepare($sql . ") " . $sqlValues . ")");

            $stmt->bindParam(':full_name', $request['full_name']);
            // $stmt->bindParam(':user_type', $request['user_type']);
            $stmt->bindParam(':email', $request['email']);
            $stmt->bindParam(':mobile', $request['mobile']);
            $stmt->bindParam(':password', $request['password']);
            $stmt->bindParam(':type', $type);
            // $stmt->bindParam(':notes', $request['notes']);
            $stmt->bindParam(':entity_id', $request['entity_id']);
            $stmt->bindParam(':added_by', $request['added_by']);
            $stmt->bindParam(':user_level', $request['user_level']);
            $stmt->bindParam(':img', $temp['img']);
            $stmt->bindParam(':date_added', $dateTime);

 if (!$stmt->execute()) { 
             
            throw new Exception("Error executing the SQL statement: " . implode(", ", $stmt->errorInfo()));
        }            $id = $pdo->lastInsertId();

            if ($type == "club_member" && $id) {
                $stmt = $pdo->prepare("INSERT INTO `clubs_members` (`user_id`, `membership_id`, `start_date`, `end_date`, `card_img`) VALUES (:user_id, :membership_id, :start_date, :end_date, :card_img)");
                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':membership_id', $request['membership_id']);
                $stmt->bindParam(':start_date', $request['start_date']);
                $stmt->bindParam(':end_date', $request['end_date']);
                $stmt->bindParam(':card_img', $temp['card_img']);
                $res = $stmt->execute();
            } elseif (($type == "captain" && $id) || ($type == "delivery" && $id)) {
                $stmt = $pdo->prepare("INSERT INTO `captains` (`user_id`, `membership_type`, `licence`, `car_licence`) VALUES (:user_id, :membership_type, :licence, :car_licence)");
                $stmt->bindParam(':user_id', $id);
                $stmt->bindParam(':membership_type', $request['membership_type']);
                $stmt->bindParam(':licence', $temp['licence']);
                $stmt->bindParam(':car_licence', $temp['car_licence']);
                $res = $stmt->execute();
            }

            return $res !== false ? $id : $res;
        } else {
            // Edit
            $sql = "UPDATE `users` SET ";
            $sql .= isset($request['email']) ? " `email` = :email," : "";
            $sql .= isset($request['status']) ? " `status` = :status," : "";
            $sql .= isset($request['notes']) ? " `notes` = :notes," : "";
            $sql .= " `modified_by` = :modified_by,";
            $sql .= " `modified_date` = :modified_date";
            $sql .= " WHERE `id` = :user_id";

            $stmt = $pdo->prepare($sql);

            if (isset($request['email'])) $stmt->bindParam(':email', $request['email']);
            if (isset($request['status'])) $stmt->bindParam(':status', $request['status'] === 'true' ? 1 : 0);
            if (isset($request['notes'])) $stmt->bindParam(':notes', $request['notes']);
            $stmt->bindParam(':modified_by', $request['modified_by']);
            $stmt->bindParam(':modified_date', $dateTime);
            $stmt->bindParam(':user_id', $user_id);

            $res = $stmt->execute();

            if ($type == "club_member" && $res) {
                $stmt = $pdo->prepare("UPDATE `clubs_members` SET `membership_id` = :membership_id, `start_date` = :start_date, `end_date` = :end_date, `card_img` = :card_img WHERE `user_id` = :user_id");
                $stmt->bindParam(':membership_id', $request['membership_id']);
                $stmt->bindParam(':start_date', $request['start_date']);
                $stmt->bindParam(':end_date', $request['end_date']);
                $stmt->bindParam(':card_img', $temp['card_img']);
                $stmt->bindParam(':user_id', $user_id);
                $res = $stmt->execute();
            } elseif (($type == "captain" && $res) || ($type == "delivery" && $res)) {
                $stmt = $pdo->prepare("UPDATE `captains` SET `membership_type` = :membership_type, `licence` = :licence, `car_licence` = :car_licence WHERE `user_id` = :user_id");
                $stmt->bindParam(':membership_type', $request['membership_type']);
                $stmt->bindParam(':licence', $temp['licence']);
                $stmt->bindParam(':car_licence', $temp['car_licence']);
                $stmt->bindParam(':user_id', $user_id);
                $res = $stmt->execute();
            }

            return $res;
        }
    } catch (PDOException $e) {
        // Log error message (assumes a logging function is available)
        error_log($e->getMessage());
        return false;
    }
}

function addQRCode($user_id, $name){
    // $qrCodePathInDb = 'qr_codes' . $user_id . '.png';
    
     $sql = " UPDATE `users` SET `qr_code` = '{$name}' WHERE `id` = '{$user_id}' ";
    //  echo $sql;die();
     
     return $this->mDb->query($sql);
}

function getUserScanInfo($user_id, $entity_id, $lang_code) {
    try {
        $sql = "SELECT u.email, u.full_name, u.mobile, u.img, ms.entity_id, ms.plan_type, ms.start_date, ms.end_date 
                FROM users u
                LEFT JOIN member_subscription ms ON u.id = ms.user_id
                LEFT JOIN entities e ON e.id = ms.entity_id
                LEFT JOIN entities_langs el ON el.entity_id = :entity_id
                WHERE u.id = :user_id AND el.lang_code = :lang_code AND e.id = :entity_id";
        
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for retrieving user scan info.");
        }

        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->bindParam(':entity_id', $entity_id, PDO::PARAM_INT);
        $stmt->bindParam(':lang_code', $lang_code, PDO::PARAM_STR);
        $stmt->execute();
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

        return $result;
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}
function getAllUsersDataFromQRCode($user_id){
    
    // Perform a database query to fetch the user data
    $sql = "SELECT u.*, ms.* FROM `users` u ";
    $sql .= "LEFT JOIN `member_subscription` ms ON u.id = ms.user_id ";
    $sql .= "WHERE u.id = '{$user_id}'";
    
    // echo $sql; die();
    $result = $this -> mDb -> getAll($sql);
    
        return $result;
    }

function addQrcodeHistoryInfo($user_id, $entity_id, $added_by) {
    try {
        $sql = "INSERT INTO qrcodehistory_info (entity_id, added_by, user_id) VALUES (:entity_id, :added_by, :user_id)";
        
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for adding QR code history info.");
        }

        $stmt->bindParam(':entity_id', $entity_id, PDO::PARAM_INT);
        $stmt->bindParam(':added_by', $added_by, PDO::PARAM_INT);
        $stmt->bindParam(':user_id', $user_id, PDO::PARAM_INT);
        $stmt->execute();

        return true;
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}
function getQrcodeHistoryInfo($searchName, $searchUserMemberShipID, $searchDateFrom, $searchDateTo, $user_id, $entity_id) {
    try {
        $sql = "SELECT cm.membership_id, u.full_name, uu.full_name AS keeper, u.mobile, el.name, qr.*
                FROM qrcodehistory_info qr
                LEFT JOIN clubs_members cm ON cm.user_id = qr.user_id
                LEFT JOIN entities_langs el ON (el.entity_id = qr.entity_id AND el.lang_code = 'ar')
                LEFT JOIN users u ON u.id = qr.user_id
                LEFT JOIN users uu ON uu.id = qr.added_by
                WHERE qr.id > 0 AND (qr.added_by = :user_id OR qr.entity_id = :entity_id)";
                
        $params = array(
            'user_id' => $user_id,
            'entity_id' => $entity_id
        );
        
        if ($searchName) {
            $sql .= " AND u.full_name LIKE :searchName";
            $params['searchName'] = '%' . $searchName . '%';
        }
        if ($searchDateFrom && $searchDateTo) {
            $sql .= " AND qr.date_added BETWEEN :searchDateFrom AND :searchDateTo";
            $params['searchDateFrom'] = $searchDateFrom;
            $params['searchDateTo'] = $searchDateTo;
        }
        if ($searchUserMemberShipID) {
            $sql .= " AND cm.membership_id LIKE :searchUserMemberShipID";
            $params['searchUserMemberShipID'] = '%' . $searchUserMemberShipID . '%';
        }
        
        $stmt = $this->mDb->connect()->prepare($sql);

        if (!$stmt) {
            throw new Exception("Error preparing the SQL statement for retrieving QR code history info.");
        }

        foreach ($params as $paramKey => $paramValue) {
            $stmt->bindParam(':' . $paramKey, $paramValue, PDO::PARAM_STR);
        }
        
        $stmt->execute();
        $result = $stmt->fetchAll(PDO::FETCH_ASSOC);

        return $result;
    } catch (PDOException $e) {
        // Log the error for debugging
        throw new Exception("Database Error: " . $e->getMessage());
    } catch (Exception $e) {
        // Log the error
        throw new Exception("Error: " . $e->getMessage());
    }
}
function getQrcodeHistorycount(){
 $sql = "SELECT COUNT(`id`) as 'count' FROM `qrcodehistory_info`";
    
    return $this -> mDb -> getOne($sql); 
    
}











}?>